#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <getopt.h>
#include "objz80.h"

void help(void)
{
    printf("mteg's z80 assembler\n");
    printf("written 2001, licensed under GNU General Public License\n");
    printf("\nusage:\n  asmz80 [-o outfile] infile\n\n");
}

int main(int argc, char ** argv)
{
    int opt;
    char * outfile = "z80.out";
    char * infile;
    unsigned char * inmem;
    int fd, flen;
    
    fi_reset();
    
    for(;;)
    {
	opt=getopt(argc,argv,"ho:");
        if(opt==EOF) break;
	switch(opt)
	{
	    case 'h':
		help();
		exit(0);
		break;
	    case 'o': if(optarg) outfile=strdup(optarg); break;
	}
    }
    if(!(infile = argv[optind]))
    {
	fprintf(stderr,"No input files specified ! \n");
	exit(1);
    }
    if(!(inmem = load(infile, &flen)))
    {
	fprintf(stderr,"Unable to load the input file!\n");
	exit(1);
    }
    if((fd = open(outfile, O_WRONLY|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR|S_IROTH|S_IRGRP)) == -1)
    {
	fprintf(stderr,"Unable to open the output file!\n");
	exit(1);
    }
    assemble(inmem, flen, fd);
    return(0);
}
