
s_syscall_table
    word s_math_printnum
    word s_math_div21
    word s_malloc
    word s_mfree
    word s_task_create
    word s_task_add
    word s_util_strlen
    word s_util_strcmp
    word s_util_strncmp
    word s_fs_nextrec
    word s_fs_findrec
    word s_fs_getroot
    word s_fs_getent
    word s_fs_enterdir
    word s_fs_getfile
    word s_util_printf
    word s_util_fillblock
    word s_util_hangup
    word s_math_cprintnum
    word s_ccon_syschvt
    word s_ccon_syswrite
    word s_ccon_waitkey
    word s_util_readln
    word s_task_remtask
    word s_task_suspend
    word s_ccon_bkspc
    
# perform a system call


s_syscall
    
    pop hl
    ld a, (hl)		; read call code
    inc hl
    push hl		; repair return address
    
    push de

    ld hl, s_syscall_table
    ld d, #0
    ld e, a
    add hl, de
    add hl, de
    
    ld e, (hl)
    inc hl
    ld d, (hl)
    push de
    pop hl
    
    pop de
    
    push de
    push af
    push bc
    push iy	; store registers
    
    ld iy, s_syscall_return
    push iy	; store return address
    
    jp (hl)
s_syscall_return
    pop iy
    pop bc
    pop af
    pop de
    ret

s_ishlzero
    inc h
    dec h
    jr nz, hl_nonzero
    inc l
    dec l
    jr nz, hl_nonzero
    cp a	; generate zero flag
hl_nonzero
    ret

!global s_syscall
!global s_syscall_return
!global s_ishlzero

